/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "adc.h"
#include "can.h"
#include "dma.h"
#include "spi.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

#include "bsp_oled.h"
#include "bsp_usart.h"
#include "bsp_key.h"
#include "bsp_led.h"
#include "bsp_can.h"
#include "bsp_pwm.h"
#include "bsp_uart.h"


#include "pid.h"
#include "motor.h"
#include "oled.h"
#include "string.h"
#include "list_motor.h"

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
int16_t led_cnt;
float target_speed;

extern RC_ctrl_t rc_ctrl;	
//uint16_t pwm_pulse = 1080;  // default pwm pulse width:1080~1920



/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_USART1_UART_Init();
  MX_ADC1_Init();
  MX_SPI1_Init();
  MX_CAN1_Init();
  MX_TIM1_Init();
  /* USER CODE BEGIN 2 */
	HAL_GPIO_WritePin(GPIOH, POWER1_CTRL_Pin|POWER2_CTRL_Pin|POWER3_CTRL_Pin|POWER4_CTRL_Pin, GPIO_PIN_SET); // switch on 24v power
	
	/* open dbus uart receive it */
	dbus_uart_init();
	
	//Init OLED
	oled_init();
	oled_clear(Pen_Clear);
	oled_LOGO();
	oled_refresh_gram();
	
	HAL_GPIO_WritePin(LED_A_GPIO_Port, LED_A_Pin, GPIO_PIN_RESET);
	HAL_Delay(10);  
	
	oled_clear(Pen_Clear);
	oled_refresh_gram();
	
	
	can_user_init(&hcan1);                   // config can filter, start can
	pwm_init();                              // start pwm output
	motors_all_init();
	//PWM_ScaleAll(&htim1);									   // etalonnage du PWM entre 0 et 1 (a faire uniquement lors de l'installation des moteurs la 1ere fois) 

  /* USER CODE END 2 */
 
 

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
				
		/* scan is key be pressed down to change target speed and pwm pulse */
    if (key_scan())
    {
			m3508_frontleft.target += 500;
			m3508_frontright.target += 500;
			m3508_backleft.target += 500;
			m3508_backright.target += 500;
			
      if (m3508_frontleft.target > 2000)
      {
				m3508_frontleft.target = 0;
				m3508_frontright.target = 0;
				m3508_backleft.target = 0;
				m3508_backright.target = 0;
      }
//			PWM_SetAllDuty(&htim1, 0.1f, 0.1f, 0.1f, 0.1f);
//			HAL_Delay(2500);
//			PWM_SetAllDuty(&htim1, 0, 0, 0, 0);
    }
		
		if (rc_ctrl.rc.sw[0] == 2)
    {
			m2006.target = 0;
    };
		if (rc_ctrl.rc.sw[0] == 3)
    {
			m2006.target = 2000;
    };
		if (rc_ctrl.rc.sw[0] == 1)
    {
			m2006.target = 5000;
    };
		
		if (rc_ctrl.rc.sw[1] == 2)
    {
			PWM_SetAllDuty(&htim1, 0.0f, 0.0f, 0.0f, 0.0f);
    };
		if (rc_ctrl.rc.sw[1] == 3)
    {
			PWM_SetAllDuty(&htim1, 0.25f, 0.25f, 0.25f, 0.25f);
    };
		if (rc_ctrl.rc.sw[1] == 1)
    {
			PWM_SetAllDuty(&htim1, 0.5f, 0.5f, 0.5f, 0.5f);
    };
		

		m3508_frontleft.target =  -MAX_BASE_SPEED_COEFF*(rc_ctrl.rc.ch[0] + rc_ctrl.rc.ch[1] + rc_ctrl.rc.ch[4]);
		m3508_frontright.target = MAX_BASE_SPEED_COEFF*(rc_ctrl.rc.ch[0] - rc_ctrl.rc.ch[1] - rc_ctrl.rc.ch[4]);
		m3508_backleft.target =   MAX_BASE_SPEED_COEFF*(rc_ctrl.rc.ch[0] + rc_ctrl.rc.ch[1] - rc_ctrl.rc.ch[4]);
		m3508_backright.target =  -MAX_BASE_SPEED_COEFF*(rc_ctrl.rc.ch[0] - rc_ctrl.rc.ch[1] + rc_ctrl.rc.ch[4]);
		
		gm6020_down.target = gm6020_down.target - rc_ctrl.rc.ch[3]*0.1;
		gm6020_up.target = gm6020_up.target + rc_ctrl.rc.ch[2]*0.04;
		
		
		if (gm6020_down.target > gm6020_down.MAX_POSITION){gm6020_down.target = gm6020_down.MAX_POSITION;}
		if (gm6020_down.target < gm6020_down.MIN_POSITION){gm6020_down.target = gm6020_down.MIN_POSITION;}
		if (gm6020_up.target > gm6020_up.MAX_POSITION){gm6020_up.target = gm6020_up.MAX_POSITION;}
		if (gm6020_up.target < gm6020_up.MIN_POSITION){gm6020_up.target = gm6020_up.MIN_POSITION;}
		

		get_motor_data(&m3508_frontleft);
		get_motor_data(&m3508_frontright);
		get_motor_data(&m3508_backleft);
		get_motor_data(&m3508_backright);
		get_motor_data(&m2006);
		get_motor_data(&gm6020_up);
		get_motor_data(&gm6020_down);

		/*Affichage de donnees sur le OLED*/
		oled_clear(Pen_Clear);
		oled_printf(1, 1, "M3508");
		oled_printf(2, 1,"  Target: %f", m3508_frontleft.target);
		oled_printf(3, 1,"  Speed: %i", m3508_frontleft.info.M3508_info.speed);
		oled_printf(4, 1,"  Angle: %i", m3508_frontleft.info.M3508_info.angle);
		oled_refresh_gram();

//		oled_clear(Pen_Clear);
//		oled_printf(0, 1, "Manette");
//		oled_printf(1, 1,"  CH1: %i", rc_ctrl.rc.ch[0]);
//		oled_printf(2, 1,"  CH2: %i", rc_ctrl.rc.ch[1]);
//		oled_printf(3, 1,"  CH3: %i", rc_ctrl.rc.ch[2]);
//		oled_printf(4, 1,"  CH4: %i", rc_ctrl.rc.ch[3]);
//		oled_refresh_gram();
		
     /* led blink */
    led_cnt ++;
    if (led_cnt == 250)
    {
      led_cnt = 0;
      LED_RED_TOGGLE(); //blink cycle 500ms
    }
		
		set_motor_speed(&m3508_frontleft);
		set_motor_speed(&m3508_frontright);
		set_motor_speed(&m3508_backleft);
		set_motor_speed(&m3508_backright);
		set_motor_speed(&m2006);
		set_motor_position(&gm6020_up);
		set_motor_position(&gm6020_down);

    set_motor_voltage(0, &m3508_frontleft, &m3508_frontright, &m3508_backleft, &m3508_backright); //0x200
		set_motor_voltage(1, &gm6020_up, &gm6020_down, &m2006, NULL); //0x1ff
		
		HAL_Delay(10);	
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage 
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 6;
  RCC_OscInitStruct.PLL.PLLN = 168;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
